      WRITE(6,*)'CYLINDER LENGTH?'
      READ(5,*)CLEN
      WRITE(6,*)'SEMI-MAJOR AND MINOR LENGTHS OF ELLIPTICAL CROSS SECTIO
     .N?'
      READ(5,*)A,B
      WRITE(6,*)'NUMBER OF FACETS?'
      READ(5,*)FACETS
      N=INT((FACETS-3.)/6.+.001)
      IF(N.LT.1)N=1
      N=2*N+1
      NODES=2*N+2
      NFACET=3*N
      PI=4.*ATAN(1.)
      OPEN(1,STATUS='UNKNOWN',FILE='CYLINDER.SRF')
      WRITE(1,*)'CYLINDER'
      WRITE(1,*)'4'
      WRITE(1,*)'1 ',NODES,NFACET,' 4 2'
      WRITE(1,*)'1. 1. 1. 1 1.'
      WRITE(1,*)0.,0.,-CLEN/2.
      DO 1 K=1,2
      Z=CLEN*FLOAT(K-1)-CLEN/2.
      DO 2 J=1,N
      THETA=2.*PI*FLOAT(J-1)/FLOAT(N)
      R=1./((COS(THETA)/A)**2+(SIN(THETA)/B)**2)
      R=SQRT(R)
      X=-R*COS(THETA)
      Y=-R*SIN(THETA)
      WRITE(1,*)X,Y,Z
    2 CONTINUE
    1 CONTINUE
      WRITE(1,*)0.,0.,CLEN/2.
      DO 3 I=1,N-1
      WRITE(1,*)'3 1 ',I+2,I+1,' 1'
    3 CONTINUE
      WRITE(1,*)'3 1 2 ',N+1,' 1'
      DO 4 I=3,1+N
      WRITE(1,*)'4 1 ',I+N,I+N-1,I-1,I
    4 CONTINUE
      WRITE(1,*)'4 1 ',2+N,1+2*N,1+N,' 2'
      DO 7 I=NODES-N,NODES-2
      WRITE(1,*)'3 1 ',NODES,I,I+1
    7 CONTINUE
      WRITE(1,*)'3 1 ',NODES,NODES-1,NODES-N
      CLOSE(1)
      STOP
      END
