      PI=4.*ATAN(1.)
      WRITE(6,*)'DIAMETER AND FOCAL LENGTH OF PARABOLA?'
      READ(5,*)RAD,FL
      RAD=RAD/2.
      WRITE(6,*)'NUMBER OF FACETS IN PARABOLA?'
      READ(5,*)FACET
      FACET=SQRT(FACET)
      N=INT(FACET+.001)
      NFACET=N**2
      NODES=NFACET+1
      WRITE(6,*)'INPUT AN INTEGER 1 IF YOU WANT A PYRAMIDAL HORN AT THE
     .FOCAL POINT.'
      READ(5,*)IHORN
      IF(IHORN.NE.1)IHORN=0
      IBACK=0
      IF(IHORN.EQ.1)WRITE(6,*)'INPUT ANOTHER INTEGER 1 IF YOU WANT THE B
     .ACK OF THE HORN COVERED.'
      IF(IHORN.EQ.1)READ(5,*)IBACK
      IF(IBACK.NE.1)IBACK=0
      OPEN(1,STATUS='UNKNOWN',FILE='PARABOLA.SRF')
      IF(IHORN.EQ.0)WRITE(1,*)'PARABOLA'
      IF(IHORN.EQ.1)WRITE(1,*)'PARABOLIC DISH WITH PYRAMIDAL HORN FEED'
      WRITE(1,*)'4'
      NMAT=1+IHORN
      WRITE(1,*)NMAT,NODES+IHORN*8,NFACET+IHORN*4+IBACK,' 4 2'
      WRITE(1,*)'.8 2. .1 3 .2'
      IF(IHORN.EQ.1)WRITE(1,*)'1. 1. 1. 1 1.'
      WRITE(1,*)'0. 0. 0.'
      DO 1 I=1,N
      R=FLOAT(I)*RAD/FLOAT(N)
      Z=R**2/4./FL
      IF(FL.GE.1.E30)Z=0.
      DO 2 J=1,N
      ANG=2.*PI*FLOAT(J-1)/FLOAT(N)
      X=R*COS(ANG)
      Y=R*SIN(ANG)
      WRITE(1,*)X,Y,Z
    2 CONTINUE
    1 CONTINUE
      IF(IHORN.EQ.0)GO TO 6
      HT=RAD/10.
      HB=HT/3.
      HD=3.*HT
      WRITE(1,*)-HT,-HT,FL
      WRITE(1,*)HT,-HT,FL
      WRITE(1,*)HT,HT,FL
      WRITE(1,*)-HT,HT,FL
      WRITE(1,*)-HB,-HB,FL+HD
      WRITE(1,*)HB,-HB,FL+HD
      WRITE(1,*)HB,HB,FL+HD
      WRITE(1,*)-HB,HB,FL+HD
    6 CONTINUE
      DO 3 I=1,N-1
      WRITE(1,*)'3 1 1 ',I+2,I+1
    3 CONTINUE
      WRITE(1,*)'3 1 1 2 ',N+1
      DO 4 I=2,N
      DO 5 J=I,I+N-2
      K=(I-2)*(N-1)+J
      WRITE(1,*)'4 1 ',K,K+1,K+1+N,K+N
    5 CONTINUE
      K=(I-1)*N+1
      L=K-N+1
      WRITE(1,*)'4 1 ',K,L,L+N,K+N
    4 CONTINUE
      IF(IHORN.EQ.0)GO TO 7
      WRITE(1,*)'4 2 ',NODES+1,NODES+5,NODES+8,NODES+4
      WRITE(1,*)'4 2 ',NODES+2,NODES+6,NODES+5,NODES+1
      WRITE(1,*)'4 2 ',NODES+2,NODES+3,NODES+7,NODES+6
      WRITE(1,*)'4 2 ',NODES+4,NODES+8,NODES+7,NODES+3
      IF(IBACK.EQ.1)WRITE(1,*)'4 2 ',NODES+5,NODES+6,NODES+7,NODES+8
    7 CONTINUE
      CLOSE(1)
      STOP
      END
