      WRITE(6,*)'ELLIPSOID SEMI-PRINCIPAL AXIS LENGTHS?'
      READ(5,*)A,B,C
      WRITE(6,*)'NUMBER OF FACETS?'
      READ(5,*)FACETS
      FACETS=(SQRT(1.+4.*FACETS)-3.)/4.
      N=INT(FACETS+.001)
      N=2*N+1
      IF(N.LT.5)N=5
      HN=FLOAT(N+1)/2.
      NODES=N**2+2
      NFACET=NODES-2+N
      PI=4.*ATAN(1.)
      OPEN(1,STATUS='UNKNOWN',FILE='ELLPSOID.SRF')
      WRITE(1,*)'ELLIPSOID'
      WRITE(1,*)'4'
      WRITE(1,*)'1 ',NODES,NFACET,' 4 2'
      WRITE(1,*)'1. 1. 1. 1 1.'
      WRITE(1,*)0.,0.,-C
      DO 1 K=1,N
      Z=C*FLOAT(K)/HN-C
      DO 2 J=1,N
      THETA=2.*PI*FLOAT(J-1)/FLOAT(N)
      R=(1.-(Z/C)**2)/((COS(THETA)/A)**2+(SIN(THETA)/B)**2)
      R=SQRT(R)
      X=-R*COS(THETA)
      Y=-R*SIN(THETA)
      WRITE(1,*)X,Y,Z
    2 CONTINUE
    1 CONTINUE
      WRITE(1,*)0.,0.,C
      DO 3 I=1,N-1
      WRITE(1,*)'3 1 ',I+2,I+1,' 1'
    3 CONTINUE
      WRITE(1,*)'3 1 2 ',N+1,' 1'
      DO 6 J=1,N*(N-2)+1,N
      DO 4 I=J+2,J+N
      WRITE(1,*)'4 1 ',I+N,I+N-1,I-1,I
    4 CONTINUE
      WRITE(1,*)'4 1 ',J+1+N,J+2*N,J+N,J+1
    6 CONTINUE
      DO 7 I=NODES-N,NODES-2
      WRITE(1,*)'3 1 ',NODES,I,I+1
    7 CONTINUE
      WRITE(1,*)'3 1 ',NODES,NODES-1,NODES-N
      CLOSE(1)
      STOP
      END
